#include <vxWorks.h>
#include <semLib.h>
#include "ellLib.h"
#include "fast_lock.h"
#include "link.h"
#include "tsDefs.h"

#ifndef INCmcaSTRTH
#define INCmcaSTRTH
typedef enum {
	mcaSTRT_Done,
	mcaSTRT_Acquire
}mcaSTRT;
#endif /*INCmcaSTRTH*/

#ifndef INCmcaREADH
#define INCmcaREADH
typedef enum {
	mcaREAD_Done,
	mcaREAD_Read
}mcaREAD;
#endif /*INCmcaREADH*/

#ifndef INCmcaR0IPH
#define INCmcaR0IPH
typedef enum {
	mcaR0IP_N,
	mcaR0IP_Y
}mcaR0IP;
#endif /*INCmcaR0IPH*/

#ifndef INCmcaMODEH
#define INCmcaMODEH
typedef enum {
	mcaMODE_PHA,
	mcaMODE_MCS,
	mcaMODE_List
}mcaMODE;
#endif /*INCmcaMODEH*/

#ifndef INCmcaERASH
#define INCmcaERASH
typedef enum {
	mcaERAS_Done,
	mcaERAS_Erase
}mcaERAS;
#endif /*INCmcaERASH*/

#ifndef INCmcaCHASH
#define INCmcaCHASH
typedef enum {
	mcaCHAS_Internal,
	mcaCHAS_External
}mcaCHAS;
#endif /*INCmcaCHASH*/
#ifndef INCmcaH
#define INCmcaH
typedef struct mcaRecord {
	char		name[29]; /*Record Name*/
	char		desc[29]; /*Descriptor*/
	char		asg[29]; /*Access Security Group*/
	unsigned short	scan;	/*Scan Mechanism*/
	unsigned short	pini;	/*Process at iocInit*/
	short		phas;	/*Scan Phase*/
	short		evnt;	/*Event Number*/
	short		tse;	/*Time Stamp Event*/
	DBLINK		tsel;	/*Time Stamp Link*/
	unsigned short	dtyp;	/*Device Type*/
	short		disv;	/*Disable Value*/
	short		disa;	/*Disable*/
	DBLINK		sdis;	/*Scanning Disable*/
	FAST_LOCK	mlok;	/*Monitor fastlock*/
	ELLLIST		mlis;	/*Monitor List*/
	unsigned char	disp;	/*Disable putField*/
	unsigned char	proc;	/*Force Processing*/
	unsigned short	stat;	/*Alarm Status*/
	unsigned short	sevr;	/*Alarm Severity*/
	unsigned short	nsta;	/*New Alarm Status*/
	unsigned short	nsev;	/*New Alarm Severity*/
	unsigned short	acks;	/*Alarm Ack Severity*/
	unsigned short	ackt;	/*Alarm Ack Transient*/
	unsigned short	diss;	/*Disable Alarm Sevrty*/
	unsigned char	lcnt;	/*Lock Count*/
	unsigned char	pact;	/*Record active*/
	unsigned char	putf;	/*dbPutField process*/
	unsigned char	rpro;	/*Reprocess */
	void		*asp;	/*Access Security Pvt*/
	void		*ppn;	/*addr of PUTNOTIFY*/
	void		*ppnn;	/*next record PUTNOTIFY*/
	void		*spvt;	/*Scan Private*/
	void		*rset;	/*Address of RSET*/
	struct dset	*dset;	/*DSET address*/
	void		*dpvt;	/*Device Private*/
	void		*rdes;	/*Address of dbRecordType*/
	void		*lset;	/*Lock Set*/
	unsigned short	prio;	/*Scheduling Priority*/
	unsigned char	tpro;	/*Trace Processing*/
	char bkpt;	/*Break Point*/
	unsigned char	udf;	/*Undefined*/
	TS_STAMP	time;	/*Time*/
	DBLINK		flnk;	/*Forward Process Link*/
	float		vers;	/*Code Version*/
	void *val;	/*Value*/
	void *bptr;	/*Buffer Pointer*/
	void *bg;	/*Background*/
	void *pbg;	/*Background buffer*/
	float		hopr;	/*High Operating Range*/
	float		lopr;	/*Low Operating Range*/
	long		nmax;	/*Max number of channels*/
	long		nord;	/*Number of channels read*/
	short		prec;	/*Display Precision*/
	unsigned short	ftvl;	/*Field Type of Value*/
	unsigned short	strt;	/*Start Acquire*/
	unsigned short	stop;	/*Stop Acquire*/
	unsigned short	acqg;	/*Acquiring*/
	unsigned short	read;	/*Read array*/
	unsigned short	rdng;	/*Reading array*/
	unsigned short	eras;	/*Erase array*/
	unsigned short	chas;	/*Channel-advance source*/
	long		nuse;	/* # of channels to use*/
	long		seq;	/*Time sequence #*/
	float		dwel;	/*Dwell time per channel*/
	long		pscl;	/*Channel advance prescale*/
	float		prtm;	/*Preset real time*/
	float		pltm;	/*Preset live time*/
	long		pct;	/*Preset counts*/
	long		pctl;	/*Preset count low channe*/
	long		pcth;	/*Preset count high chann*/
	long		pswp;	/*Preset number of sweeps*/
	unsigned short	mode;	/*Mode PHA/MCS/LIST*/
	float		calo;	/*Calibration offset*/
	float		cals;	/*Calibration slope*/
	float		calq;	/*Calibration quadratic*/
	char		egu[16]; /*Calibration Units Name*/
	float		tth;	/*Two-theta*/
	float		ertm;	/*Elapsed real time*/
	float		eltm;	/*Elapsed live time*/
	char		stim[40]; /*Acquisition start time*/
	long		act;	/*Actual counts in pregio*/
	short		nack;	/*Message not acknowledge*/
	DBLINK		inp;	/*Input Specification*/
	DBLINK		siol;	/*Sim Input Specifctn*/
	DBLINK		siml;	/*Sim Mode Location*/
	unsigned short	simm;	/*Simulation Mode*/
	unsigned short	sims;	/*Sim mode Alarm Svrty*/
	unsigned long	mmap;	/*Monitor map*/
	unsigned long	rmap;	/*ROI monitor map*/
	unsigned long	newv;	/*New Value map*/
	long		r0lo;	/*Region 0 low channel*/
	long		r0hi;	/*Region 0 high channel*/
	short		r0bg;	/*Region 0 bkgrnd chans*/
	unsigned short	r0ip;	/*Region 0 is preset*/
	long		r1lo;	/*Region 1 low channel*/
	long		r1hi;	/*Region 1 high channel*/
	short		r1bg;	/*Region 1 bkgrnd chans*/
	unsigned short	r1ip;	/*Region 1 is preset*/
	long		r2lo;	/*Region 2 low channel*/
	long		r2hi;	/*Region 2 high channel*/
	short		r2bg;	/*Region 2 bkgrnd chans*/
	unsigned short	r2ip;	/*Region 2 is preset*/
	long		r3lo;	/*Region 3 low channel*/
	long		r3hi;	/*Region 3 high channel*/
	short		r3bg;	/*Region 3 bkgrnd chans*/
	unsigned short	r3ip;	/*Region 3 is preset*/
	long		r4lo;	/*Region 4 low channel*/
	long		r4hi;	/*Region 4 high channel*/
	short		r4bg;	/*Region 4 bkgrnd chans*/
	unsigned short	r4ip;	/*Region 4 is preset*/
	long		r5lo;	/*Region 5 low channel*/
	long		r5hi;	/*Region 5 high channel*/
	short		r5bg;	/*Region 5 bkgrnd chans*/
	unsigned short	r5ip;	/*Region 5 is preset*/
	long		r6lo;	/*Region 6 low channel*/
	long		r6hi;	/*Region 6 high channel*/
	short		r6bg;	/*Region 6 bkgrnd chans*/
	unsigned short	r6ip;	/*Region 6 is preset*/
	long		r7lo;	/*Region 7 low channel*/
	long		r7hi;	/*Region 7 high channel*/
	short		r7bg;	/*Region 7 bkgrnd chans*/
	unsigned short	r7ip;	/*Region 7 is preset*/
	long		r8lo;	/*Region 8 low channel*/
	long		r8hi;	/*Region 8 high channel*/
	short		r8bg;	/*Region 8 bkgrnd chans*/
	unsigned short	r8ip;	/*Region 8 is preset*/
	long		r9lo;	/*Region 9 low channel*/
	long		r9hi;	/*Region 9 high channel*/
	short		r9bg;	/*Region 9 bkgrnd chans*/
	unsigned short	r9ip;	/*Region 9 is preset*/
	double		r0;	/*Region 0 counts*/
	double		r0n;	/*Region 0 net counts*/
	double		r0p;	/*Region 0 preset count*/
	double		r1;	/*Region 1 counts*/
	double		r1n;	/*Region 1 net counts*/
	double		r1p;	/*Region 1 preset count*/
	double		r2;	/*Region 2 counts*/
	double		r2n;	/*Region 2 net counts*/
	double		r2p;	/*Region 2 preset count*/
	double		r3;	/*Region 3 counts*/
	double		r3n;	/*Region 3 net counts*/
	double		r3p;	/*Region 3 preset count*/
	double		r4;	/*Region 4 counts*/
	double		r4n;	/*Region 4 net counts*/
	double		r4p;	/*Region 4 preset count*/
	double		r5;	/*Region 5 counts*/
	double		r5n;	/*Region 5 net counts*/
	double		r5p;	/*Region 5 preset count*/
	double		r6;	/*Region 6 counts*/
	double		r6n;	/*Region 6 net counts*/
	double		r6p;	/*Region 6 preset*/
	double		r7;	/*Region 7 counts*/
	double		r7n;	/*Region 7 net counts*/
	double		r7p;	/*Region 7 preset*/
	double		r8;	/*Region 8 counts*/
	double		r8n;	/*Region 8 net counts*/
	double		r8p;	/*Region 8 preset*/
	double		r9;	/*Region 9 counts*/
	double		r9n;	/*Region 9 net counts*/
	double		r9p;	/*Region 9 preset*/
	char		r0nm[16]; /*Region 0 name*/
	char		r1nm[16]; /*Region 1 name*/
	char		r2nm[16]; /*Region 2 name*/
	char		r3nm[16]; /*Region 3 name*/
	char		r4nm[16]; /*Region 4 name*/
	char		r5nm[16]; /*Region 5 name*/
	char		r6nm[16]; /*Region 6 name*/
	char		r7nm[16]; /*Region 7 name*/
	char		r8nm[16]; /*Region 8 name*/
	char		r9nm[16]; /*Region 9 name*/
} mcaRecord;
#define mcaRecordNAME	0
#define mcaRecordDESC	1
#define mcaRecordASG	2
#define mcaRecordSCAN	3
#define mcaRecordPINI	4
#define mcaRecordPHAS	5
#define mcaRecordEVNT	6
#define mcaRecordTSE	7
#define mcaRecordTSEL	8
#define mcaRecordDTYP	9
#define mcaRecordDISV	10
#define mcaRecordDISA	11
#define mcaRecordSDIS	12
#define mcaRecordMLOK	13
#define mcaRecordMLIS	14
#define mcaRecordDISP	15
#define mcaRecordPROC	16
#define mcaRecordSTAT	17
#define mcaRecordSEVR	18
#define mcaRecordNSTA	19
#define mcaRecordNSEV	20
#define mcaRecordACKS	21
#define mcaRecordACKT	22
#define mcaRecordDISS	23
#define mcaRecordLCNT	24
#define mcaRecordPACT	25
#define mcaRecordPUTF	26
#define mcaRecordRPRO	27
#define mcaRecordASP	28
#define mcaRecordPPN	29
#define mcaRecordPPNN	30
#define mcaRecordSPVT	31
#define mcaRecordRSET	32
#define mcaRecordDSET	33
#define mcaRecordDPVT	34
#define mcaRecordRDES	35
#define mcaRecordLSET	36
#define mcaRecordPRIO	37
#define mcaRecordTPRO	38
#define mcaRecordBKPT	39
#define mcaRecordUDF	40
#define mcaRecordTIME	41
#define mcaRecordFLNK	42
#define mcaRecordVERS	43
#define mcaRecordVAL	44
#define mcaRecordBPTR	45
#define mcaRecordBG	46
#define mcaRecordPBG	47
#define mcaRecordHOPR	48
#define mcaRecordLOPR	49
#define mcaRecordNMAX	50
#define mcaRecordNORD	51
#define mcaRecordPREC	52
#define mcaRecordFTVL	53
#define mcaRecordSTRT	54
#define mcaRecordSTOP	55
#define mcaRecordACQG	56
#define mcaRecordREAD	57
#define mcaRecordRDNG	58
#define mcaRecordERAS	59
#define mcaRecordCHAS	60
#define mcaRecordNUSE	61
#define mcaRecordSEQ	62
#define mcaRecordDWEL	63
#define mcaRecordPSCL	64
#define mcaRecordPRTM	65
#define mcaRecordPLTM	66
#define mcaRecordPCT	67
#define mcaRecordPCTL	68
#define mcaRecordPCTH	69
#define mcaRecordPSWP	70
#define mcaRecordMODE	71
#define mcaRecordCALO	72
#define mcaRecordCALS	73
#define mcaRecordCALQ	74
#define mcaRecordEGU	75
#define mcaRecordTTH	76
#define mcaRecordERTM	77
#define mcaRecordELTM	78
#define mcaRecordSTIM	79
#define mcaRecordACT	80
#define mcaRecordNACK	81
#define mcaRecordINP	82
#define mcaRecordSIOL	83
#define mcaRecordSIML	84
#define mcaRecordSIMM	85
#define mcaRecordSIMS	86
#define mcaRecordMMAP	87
#define mcaRecordRMAP	88
#define mcaRecordNEWV	89
#define mcaRecordR0LO	90
#define mcaRecordR0HI	91
#define mcaRecordR0BG	92
#define mcaRecordR0IP	93
#define mcaRecordR1LO	94
#define mcaRecordR1HI	95
#define mcaRecordR1BG	96
#define mcaRecordR1IP	97
#define mcaRecordR2LO	98
#define mcaRecordR2HI	99
#define mcaRecordR2BG	100
#define mcaRecordR2IP	101
#define mcaRecordR3LO	102
#define mcaRecordR3HI	103
#define mcaRecordR3BG	104
#define mcaRecordR3IP	105
#define mcaRecordR4LO	106
#define mcaRecordR4HI	107
#define mcaRecordR4BG	108
#define mcaRecordR4IP	109
#define mcaRecordR5LO	110
#define mcaRecordR5HI	111
#define mcaRecordR5BG	112
#define mcaRecordR5IP	113
#define mcaRecordR6LO	114
#define mcaRecordR6HI	115
#define mcaRecordR6BG	116
#define mcaRecordR6IP	117
#define mcaRecordR7LO	118
#define mcaRecordR7HI	119
#define mcaRecordR7BG	120
#define mcaRecordR7IP	121
#define mcaRecordR8LO	122
#define mcaRecordR8HI	123
#define mcaRecordR8BG	124
#define mcaRecordR8IP	125
#define mcaRecordR9LO	126
#define mcaRecordR9HI	127
#define mcaRecordR9BG	128
#define mcaRecordR9IP	129
#define mcaRecordR0	130
#define mcaRecordR0N	131
#define mcaRecordR0P	132
#define mcaRecordR1	133
#define mcaRecordR1N	134
#define mcaRecordR1P	135
#define mcaRecordR2	136
#define mcaRecordR2N	137
#define mcaRecordR2P	138
#define mcaRecordR3	139
#define mcaRecordR3N	140
#define mcaRecordR3P	141
#define mcaRecordR4	142
#define mcaRecordR4N	143
#define mcaRecordR4P	144
#define mcaRecordR5	145
#define mcaRecordR5N	146
#define mcaRecordR5P	147
#define mcaRecordR6	148
#define mcaRecordR6N	149
#define mcaRecordR6P	150
#define mcaRecordR7	151
#define mcaRecordR7N	152
#define mcaRecordR7P	153
#define mcaRecordR8	154
#define mcaRecordR8N	155
#define mcaRecordR8P	156
#define mcaRecordR9	157
#define mcaRecordR9N	158
#define mcaRecordR9P	159
#define mcaRecordR0NM	160
#define mcaRecordR1NM	161
#define mcaRecordR2NM	162
#define mcaRecordR3NM	163
#define mcaRecordR4NM	164
#define mcaRecordR5NM	165
#define mcaRecordR6NM	166
#define mcaRecordR7NM	167
#define mcaRecordR8NM	168
#define mcaRecordR9NM	169
#endif /*INCmcaH*/
#ifdef GEN_SIZE_OFFSET
int mcaRecordSizeOffset(dbRecordType *pdbRecordType)
{
    mcaRecord *prec = 0;
  pdbRecordType->papFldDes[0]->size=sizeof(prec->name);
  pdbRecordType->papFldDes[0]->offset=(short)((char *)&prec->name - (char *)prec);
  pdbRecordType->papFldDes[1]->size=sizeof(prec->desc);
  pdbRecordType->papFldDes[1]->offset=(short)((char *)&prec->desc - (char *)prec);
  pdbRecordType->papFldDes[2]->size=sizeof(prec->asg);
  pdbRecordType->papFldDes[2]->offset=(short)((char *)&prec->asg - (char *)prec);
  pdbRecordType->papFldDes[3]->size=sizeof(prec->scan);
  pdbRecordType->papFldDes[3]->offset=(short)((char *)&prec->scan - (char *)prec);
  pdbRecordType->papFldDes[4]->size=sizeof(prec->pini);
  pdbRecordType->papFldDes[4]->offset=(short)((char *)&prec->pini - (char *)prec);
  pdbRecordType->papFldDes[5]->size=sizeof(prec->phas);
  pdbRecordType->papFldDes[5]->offset=(short)((char *)&prec->phas - (char *)prec);
  pdbRecordType->papFldDes[6]->size=sizeof(prec->evnt);
  pdbRecordType->papFldDes[6]->offset=(short)((char *)&prec->evnt - (char *)prec);
  pdbRecordType->papFldDes[7]->size=sizeof(prec->tse);
  pdbRecordType->papFldDes[7]->offset=(short)((char *)&prec->tse - (char *)prec);
  pdbRecordType->papFldDes[8]->size=sizeof(prec->tsel);
  pdbRecordType->papFldDes[8]->offset=(short)((char *)&prec->tsel - (char *)prec);
  pdbRecordType->papFldDes[9]->size=sizeof(prec->dtyp);
  pdbRecordType->papFldDes[9]->offset=(short)((char *)&prec->dtyp - (char *)prec);
  pdbRecordType->papFldDes[10]->size=sizeof(prec->disv);
  pdbRecordType->papFldDes[10]->offset=(short)((char *)&prec->disv - (char *)prec);
  pdbRecordType->papFldDes[11]->size=sizeof(prec->disa);
  pdbRecordType->papFldDes[11]->offset=(short)((char *)&prec->disa - (char *)prec);
  pdbRecordType->papFldDes[12]->size=sizeof(prec->sdis);
  pdbRecordType->papFldDes[12]->offset=(short)((char *)&prec->sdis - (char *)prec);
  pdbRecordType->papFldDes[13]->size=sizeof(prec->mlok);
  pdbRecordType->papFldDes[13]->offset=(short)((char *)&prec->mlok - (char *)prec);
  pdbRecordType->papFldDes[14]->size=sizeof(prec->mlis);
  pdbRecordType->papFldDes[14]->offset=(short)((char *)&prec->mlis - (char *)prec);
  pdbRecordType->papFldDes[15]->size=sizeof(prec->disp);
  pdbRecordType->papFldDes[15]->offset=(short)((char *)&prec->disp - (char *)prec);
  pdbRecordType->papFldDes[16]->size=sizeof(prec->proc);
  pdbRecordType->papFldDes[16]->offset=(short)((char *)&prec->proc - (char *)prec);
  pdbRecordType->papFldDes[17]->size=sizeof(prec->stat);
  pdbRecordType->papFldDes[17]->offset=(short)((char *)&prec->stat - (char *)prec);
  pdbRecordType->papFldDes[18]->size=sizeof(prec->sevr);
  pdbRecordType->papFldDes[18]->offset=(short)((char *)&prec->sevr - (char *)prec);
  pdbRecordType->papFldDes[19]->size=sizeof(prec->nsta);
  pdbRecordType->papFldDes[19]->offset=(short)((char *)&prec->nsta - (char *)prec);
  pdbRecordType->papFldDes[20]->size=sizeof(prec->nsev);
  pdbRecordType->papFldDes[20]->offset=(short)((char *)&prec->nsev - (char *)prec);
  pdbRecordType->papFldDes[21]->size=sizeof(prec->acks);
  pdbRecordType->papFldDes[21]->offset=(short)((char *)&prec->acks - (char *)prec);
  pdbRecordType->papFldDes[22]->size=sizeof(prec->ackt);
  pdbRecordType->papFldDes[22]->offset=(short)((char *)&prec->ackt - (char *)prec);
  pdbRecordType->papFldDes[23]->size=sizeof(prec->diss);
  pdbRecordType->papFldDes[23]->offset=(short)((char *)&prec->diss - (char *)prec);
  pdbRecordType->papFldDes[24]->size=sizeof(prec->lcnt);
  pdbRecordType->papFldDes[24]->offset=(short)((char *)&prec->lcnt - (char *)prec);
  pdbRecordType->papFldDes[25]->size=sizeof(prec->pact);
  pdbRecordType->papFldDes[25]->offset=(short)((char *)&prec->pact - (char *)prec);
  pdbRecordType->papFldDes[26]->size=sizeof(prec->putf);
  pdbRecordType->papFldDes[26]->offset=(short)((char *)&prec->putf - (char *)prec);
  pdbRecordType->papFldDes[27]->size=sizeof(prec->rpro);
  pdbRecordType->papFldDes[27]->offset=(short)((char *)&prec->rpro - (char *)prec);
  pdbRecordType->papFldDes[28]->size=sizeof(prec->asp);
  pdbRecordType->papFldDes[28]->offset=(short)((char *)&prec->asp - (char *)prec);
  pdbRecordType->papFldDes[29]->size=sizeof(prec->ppn);
  pdbRecordType->papFldDes[29]->offset=(short)((char *)&prec->ppn - (char *)prec);
  pdbRecordType->papFldDes[30]->size=sizeof(prec->ppnn);
  pdbRecordType->papFldDes[30]->offset=(short)((char *)&prec->ppnn - (char *)prec);
  pdbRecordType->papFldDes[31]->size=sizeof(prec->spvt);
  pdbRecordType->papFldDes[31]->offset=(short)((char *)&prec->spvt - (char *)prec);
  pdbRecordType->papFldDes[32]->size=sizeof(prec->rset);
  pdbRecordType->papFldDes[32]->offset=(short)((char *)&prec->rset - (char *)prec);
  pdbRecordType->papFldDes[33]->size=sizeof(prec->dset);
  pdbRecordType->papFldDes[33]->offset=(short)((char *)&prec->dset - (char *)prec);
  pdbRecordType->papFldDes[34]->size=sizeof(prec->dpvt);
  pdbRecordType->papFldDes[34]->offset=(short)((char *)&prec->dpvt - (char *)prec);
  pdbRecordType->papFldDes[35]->size=sizeof(prec->rdes);
  pdbRecordType->papFldDes[35]->offset=(short)((char *)&prec->rdes - (char *)prec);
  pdbRecordType->papFldDes[36]->size=sizeof(prec->lset);
  pdbRecordType->papFldDes[36]->offset=(short)((char *)&prec->lset - (char *)prec);
  pdbRecordType->papFldDes[37]->size=sizeof(prec->prio);
  pdbRecordType->papFldDes[37]->offset=(short)((char *)&prec->prio - (char *)prec);
  pdbRecordType->papFldDes[38]->size=sizeof(prec->tpro);
  pdbRecordType->papFldDes[38]->offset=(short)((char *)&prec->tpro - (char *)prec);
  pdbRecordType->papFldDes[39]->size=sizeof(prec->bkpt);
  pdbRecordType->papFldDes[39]->offset=(short)((char *)&prec->bkpt - (char *)prec);
  pdbRecordType->papFldDes[40]->size=sizeof(prec->udf);
  pdbRecordType->papFldDes[40]->offset=(short)((char *)&prec->udf - (char *)prec);
  pdbRecordType->papFldDes[41]->size=sizeof(prec->time);
  pdbRecordType->papFldDes[41]->offset=(short)((char *)&prec->time - (char *)prec);
  pdbRecordType->papFldDes[42]->size=sizeof(prec->flnk);
  pdbRecordType->papFldDes[42]->offset=(short)((char *)&prec->flnk - (char *)prec);
  pdbRecordType->papFldDes[43]->size=sizeof(prec->vers);
  pdbRecordType->papFldDes[43]->offset=(short)((char *)&prec->vers - (char *)prec);
  pdbRecordType->papFldDes[44]->size=sizeof(prec->val);
  pdbRecordType->papFldDes[44]->offset=(short)((char *)&prec->val - (char *)prec);
  pdbRecordType->papFldDes[45]->size=sizeof(prec->bptr);
  pdbRecordType->papFldDes[45]->offset=(short)((char *)&prec->bptr - (char *)prec);
  pdbRecordType->papFldDes[46]->size=sizeof(prec->bg);
  pdbRecordType->papFldDes[46]->offset=(short)((char *)&prec->bg - (char *)prec);
  pdbRecordType->papFldDes[47]->size=sizeof(prec->pbg);
  pdbRecordType->papFldDes[47]->offset=(short)((char *)&prec->pbg - (char *)prec);
  pdbRecordType->papFldDes[48]->size=sizeof(prec->hopr);
  pdbRecordType->papFldDes[48]->offset=(short)((char *)&prec->hopr - (char *)prec);
  pdbRecordType->papFldDes[49]->size=sizeof(prec->lopr);
  pdbRecordType->papFldDes[49]->offset=(short)((char *)&prec->lopr - (char *)prec);
  pdbRecordType->papFldDes[50]->size=sizeof(prec->nmax);
  pdbRecordType->papFldDes[50]->offset=(short)((char *)&prec->nmax - (char *)prec);
  pdbRecordType->papFldDes[51]->size=sizeof(prec->nord);
  pdbRecordType->papFldDes[51]->offset=(short)((char *)&prec->nord - (char *)prec);
  pdbRecordType->papFldDes[52]->size=sizeof(prec->prec);
  pdbRecordType->papFldDes[52]->offset=(short)((char *)&prec->prec - (char *)prec);
  pdbRecordType->papFldDes[53]->size=sizeof(prec->ftvl);
  pdbRecordType->papFldDes[53]->offset=(short)((char *)&prec->ftvl - (char *)prec);
  pdbRecordType->papFldDes[54]->size=sizeof(prec->strt);
  pdbRecordType->papFldDes[54]->offset=(short)((char *)&prec->strt - (char *)prec);
  pdbRecordType->papFldDes[55]->size=sizeof(prec->stop);
  pdbRecordType->papFldDes[55]->offset=(short)((char *)&prec->stop - (char *)prec);
  pdbRecordType->papFldDes[56]->size=sizeof(prec->acqg);
  pdbRecordType->papFldDes[56]->offset=(short)((char *)&prec->acqg - (char *)prec);
  pdbRecordType->papFldDes[57]->size=sizeof(prec->read);
  pdbRecordType->papFldDes[57]->offset=(short)((char *)&prec->read - (char *)prec);
  pdbRecordType->papFldDes[58]->size=sizeof(prec->rdng);
  pdbRecordType->papFldDes[58]->offset=(short)((char *)&prec->rdng - (char *)prec);
  pdbRecordType->papFldDes[59]->size=sizeof(prec->eras);
  pdbRecordType->papFldDes[59]->offset=(short)((char *)&prec->eras - (char *)prec);
  pdbRecordType->papFldDes[60]->size=sizeof(prec->chas);
  pdbRecordType->papFldDes[60]->offset=(short)((char *)&prec->chas - (char *)prec);
  pdbRecordType->papFldDes[61]->size=sizeof(prec->nuse);
  pdbRecordType->papFldDes[61]->offset=(short)((char *)&prec->nuse - (char *)prec);
  pdbRecordType->papFldDes[62]->size=sizeof(prec->seq);
  pdbRecordType->papFldDes[62]->offset=(short)((char *)&prec->seq - (char *)prec);
  pdbRecordType->papFldDes[63]->size=sizeof(prec->dwel);
  pdbRecordType->papFldDes[63]->offset=(short)((char *)&prec->dwel - (char *)prec);
  pdbRecordType->papFldDes[64]->size=sizeof(prec->pscl);
  pdbRecordType->papFldDes[64]->offset=(short)((char *)&prec->pscl - (char *)prec);
  pdbRecordType->papFldDes[65]->size=sizeof(prec->prtm);
  pdbRecordType->papFldDes[65]->offset=(short)((char *)&prec->prtm - (char *)prec);
  pdbRecordType->papFldDes[66]->size=sizeof(prec->pltm);
  pdbRecordType->papFldDes[66]->offset=(short)((char *)&prec->pltm - (char *)prec);
  pdbRecordType->papFldDes[67]->size=sizeof(prec->pct);
  pdbRecordType->papFldDes[67]->offset=(short)((char *)&prec->pct - (char *)prec);
  pdbRecordType->papFldDes[68]->size=sizeof(prec->pctl);
  pdbRecordType->papFldDes[68]->offset=(short)((char *)&prec->pctl - (char *)prec);
  pdbRecordType->papFldDes[69]->size=sizeof(prec->pcth);
  pdbRecordType->papFldDes[69]->offset=(short)((char *)&prec->pcth - (char *)prec);
  pdbRecordType->papFldDes[70]->size=sizeof(prec->pswp);
  pdbRecordType->papFldDes[70]->offset=(short)((char *)&prec->pswp - (char *)prec);
  pdbRecordType->papFldDes[71]->size=sizeof(prec->mode);
  pdbRecordType->papFldDes[71]->offset=(short)((char *)&prec->mode - (char *)prec);
  pdbRecordType->papFldDes[72]->size=sizeof(prec->calo);
  pdbRecordType->papFldDes[72]->offset=(short)((char *)&prec->calo - (char *)prec);
  pdbRecordType->papFldDes[73]->size=sizeof(prec->cals);
  pdbRecordType->papFldDes[73]->offset=(short)((char *)&prec->cals - (char *)prec);
  pdbRecordType->papFldDes[74]->size=sizeof(prec->calq);
  pdbRecordType->papFldDes[74]->offset=(short)((char *)&prec->calq - (char *)prec);
  pdbRecordType->papFldDes[75]->size=sizeof(prec->egu);
  pdbRecordType->papFldDes[75]->offset=(short)((char *)&prec->egu - (char *)prec);
  pdbRecordType->papFldDes[76]->size=sizeof(prec->tth);
  pdbRecordType->papFldDes[76]->offset=(short)((char *)&prec->tth - (char *)prec);
  pdbRecordType->papFldDes[77]->size=sizeof(prec->ertm);
  pdbRecordType->papFldDes[77]->offset=(short)((char *)&prec->ertm - (char *)prec);
  pdbRecordType->papFldDes[78]->size=sizeof(prec->eltm);
  pdbRecordType->papFldDes[78]->offset=(short)((char *)&prec->eltm - (char *)prec);
  pdbRecordType->papFldDes[79]->size=sizeof(prec->stim);
  pdbRecordType->papFldDes[79]->offset=(short)((char *)&prec->stim - (char *)prec);
  pdbRecordType->papFldDes[80]->size=sizeof(prec->act);
  pdbRecordType->papFldDes[80]->offset=(short)((char *)&prec->act - (char *)prec);
  pdbRecordType->papFldDes[81]->size=sizeof(prec->nack);
  pdbRecordType->papFldDes[81]->offset=(short)((char *)&prec->nack - (char *)prec);
  pdbRecordType->papFldDes[82]->size=sizeof(prec->inp);
  pdbRecordType->papFldDes[82]->offset=(short)((char *)&prec->inp - (char *)prec);
  pdbRecordType->papFldDes[83]->size=sizeof(prec->siol);
  pdbRecordType->papFldDes[83]->offset=(short)((char *)&prec->siol - (char *)prec);
  pdbRecordType->papFldDes[84]->size=sizeof(prec->siml);
  pdbRecordType->papFldDes[84]->offset=(short)((char *)&prec->siml - (char *)prec);
  pdbRecordType->papFldDes[85]->size=sizeof(prec->simm);
  pdbRecordType->papFldDes[85]->offset=(short)((char *)&prec->simm - (char *)prec);
  pdbRecordType->papFldDes[86]->size=sizeof(prec->sims);
  pdbRecordType->papFldDes[86]->offset=(short)((char *)&prec->sims - (char *)prec);
  pdbRecordType->papFldDes[87]->size=sizeof(prec->mmap);
  pdbRecordType->papFldDes[87]->offset=(short)((char *)&prec->mmap - (char *)prec);
  pdbRecordType->papFldDes[88]->size=sizeof(prec->rmap);
  pdbRecordType->papFldDes[88]->offset=(short)((char *)&prec->rmap - (char *)prec);
  pdbRecordType->papFldDes[89]->size=sizeof(prec->newv);
  pdbRecordType->papFldDes[89]->offset=(short)((char *)&prec->newv - (char *)prec);
  pdbRecordType->papFldDes[90]->size=sizeof(prec->r0lo);
  pdbRecordType->papFldDes[90]->offset=(short)((char *)&prec->r0lo - (char *)prec);
  pdbRecordType->papFldDes[91]->size=sizeof(prec->r0hi);
  pdbRecordType->papFldDes[91]->offset=(short)((char *)&prec->r0hi - (char *)prec);
  pdbRecordType->papFldDes[92]->size=sizeof(prec->r0bg);
  pdbRecordType->papFldDes[92]->offset=(short)((char *)&prec->r0bg - (char *)prec);
  pdbRecordType->papFldDes[93]->size=sizeof(prec->r0ip);
  pdbRecordType->papFldDes[93]->offset=(short)((char *)&prec->r0ip - (char *)prec);
  pdbRecordType->papFldDes[94]->size=sizeof(prec->r1lo);
  pdbRecordType->papFldDes[94]->offset=(short)((char *)&prec->r1lo - (char *)prec);
  pdbRecordType->papFldDes[95]->size=sizeof(prec->r1hi);
  pdbRecordType->papFldDes[95]->offset=(short)((char *)&prec->r1hi - (char *)prec);
  pdbRecordType->papFldDes[96]->size=sizeof(prec->r1bg);
  pdbRecordType->papFldDes[96]->offset=(short)((char *)&prec->r1bg - (char *)prec);
  pdbRecordType->papFldDes[97]->size=sizeof(prec->r1ip);
  pdbRecordType->papFldDes[97]->offset=(short)((char *)&prec->r1ip - (char *)prec);
  pdbRecordType->papFldDes[98]->size=sizeof(prec->r2lo);
  pdbRecordType->papFldDes[98]->offset=(short)((char *)&prec->r2lo - (char *)prec);
  pdbRecordType->papFldDes[99]->size=sizeof(prec->r2hi);
  pdbRecordType->papFldDes[99]->offset=(short)((char *)&prec->r2hi - (char *)prec);
  pdbRecordType->papFldDes[100]->size=sizeof(prec->r2bg);
  pdbRecordType->papFldDes[100]->offset=(short)((char *)&prec->r2bg - (char *)prec);
  pdbRecordType->papFldDes[101]->size=sizeof(prec->r2ip);
  pdbRecordType->papFldDes[101]->offset=(short)((char *)&prec->r2ip - (char *)prec);
  pdbRecordType->papFldDes[102]->size=sizeof(prec->r3lo);
  pdbRecordType->papFldDes[102]->offset=(short)((char *)&prec->r3lo - (char *)prec);
  pdbRecordType->papFldDes[103]->size=sizeof(prec->r3hi);
  pdbRecordType->papFldDes[103]->offset=(short)((char *)&prec->r3hi - (char *)prec);
  pdbRecordType->papFldDes[104]->size=sizeof(prec->r3bg);
  pdbRecordType->papFldDes[104]->offset=(short)((char *)&prec->r3bg - (char *)prec);
  pdbRecordType->papFldDes[105]->size=sizeof(prec->r3ip);
  pdbRecordType->papFldDes[105]->offset=(short)((char *)&prec->r3ip - (char *)prec);
  pdbRecordType->papFldDes[106]->size=sizeof(prec->r4lo);
  pdbRecordType->papFldDes[106]->offset=(short)((char *)&prec->r4lo - (char *)prec);
  pdbRecordType->papFldDes[107]->size=sizeof(prec->r4hi);
  pdbRecordType->papFldDes[107]->offset=(short)((char *)&prec->r4hi - (char *)prec);
  pdbRecordType->papFldDes[108]->size=sizeof(prec->r4bg);
  pdbRecordType->papFldDes[108]->offset=(short)((char *)&prec->r4bg - (char *)prec);
  pdbRecordType->papFldDes[109]->size=sizeof(prec->r4ip);
  pdbRecordType->papFldDes[109]->offset=(short)((char *)&prec->r4ip - (char *)prec);
  pdbRecordType->papFldDes[110]->size=sizeof(prec->r5lo);
  pdbRecordType->papFldDes[110]->offset=(short)((char *)&prec->r5lo - (char *)prec);
  pdbRecordType->papFldDes[111]->size=sizeof(prec->r5hi);
  pdbRecordType->papFldDes[111]->offset=(short)((char *)&prec->r5hi - (char *)prec);
  pdbRecordType->papFldDes[112]->size=sizeof(prec->r5bg);
  pdbRecordType->papFldDes[112]->offset=(short)((char *)&prec->r5bg - (char *)prec);
  pdbRecordType->papFldDes[113]->size=sizeof(prec->r5ip);
  pdbRecordType->papFldDes[113]->offset=(short)((char *)&prec->r5ip - (char *)prec);
  pdbRecordType->papFldDes[114]->size=sizeof(prec->r6lo);
  pdbRecordType->papFldDes[114]->offset=(short)((char *)&prec->r6lo - (char *)prec);
  pdbRecordType->papFldDes[115]->size=sizeof(prec->r6hi);
  pdbRecordType->papFldDes[115]->offset=(short)((char *)&prec->r6hi - (char *)prec);
  pdbRecordType->papFldDes[116]->size=sizeof(prec->r6bg);
  pdbRecordType->papFldDes[116]->offset=(short)((char *)&prec->r6bg - (char *)prec);
  pdbRecordType->papFldDes[117]->size=sizeof(prec->r6ip);
  pdbRecordType->papFldDes[117]->offset=(short)((char *)&prec->r6ip - (char *)prec);
  pdbRecordType->papFldDes[118]->size=sizeof(prec->r7lo);
  pdbRecordType->papFldDes[118]->offset=(short)((char *)&prec->r7lo - (char *)prec);
  pdbRecordType->papFldDes[119]->size=sizeof(prec->r7hi);
  pdbRecordType->papFldDes[119]->offset=(short)((char *)&prec->r7hi - (char *)prec);
  pdbRecordType->papFldDes[120]->size=sizeof(prec->r7bg);
  pdbRecordType->papFldDes[120]->offset=(short)((char *)&prec->r7bg - (char *)prec);
  pdbRecordType->papFldDes[121]->size=sizeof(prec->r7ip);
  pdbRecordType->papFldDes[121]->offset=(short)((char *)&prec->r7ip - (char *)prec);
  pdbRecordType->papFldDes[122]->size=sizeof(prec->r8lo);
  pdbRecordType->papFldDes[122]->offset=(short)((char *)&prec->r8lo - (char *)prec);
  pdbRecordType->papFldDes[123]->size=sizeof(prec->r8hi);
  pdbRecordType->papFldDes[123]->offset=(short)((char *)&prec->r8hi - (char *)prec);
  pdbRecordType->papFldDes[124]->size=sizeof(prec->r8bg);
  pdbRecordType->papFldDes[124]->offset=(short)((char *)&prec->r8bg - (char *)prec);
  pdbRecordType->papFldDes[125]->size=sizeof(prec->r8ip);
  pdbRecordType->papFldDes[125]->offset=(short)((char *)&prec->r8ip - (char *)prec);
  pdbRecordType->papFldDes[126]->size=sizeof(prec->r9lo);
  pdbRecordType->papFldDes[126]->offset=(short)((char *)&prec->r9lo - (char *)prec);
  pdbRecordType->papFldDes[127]->size=sizeof(prec->r9hi);
  pdbRecordType->papFldDes[127]->offset=(short)((char *)&prec->r9hi - (char *)prec);
  pdbRecordType->papFldDes[128]->size=sizeof(prec->r9bg);
  pdbRecordType->papFldDes[128]->offset=(short)((char *)&prec->r9bg - (char *)prec);
  pdbRecordType->papFldDes[129]->size=sizeof(prec->r9ip);
  pdbRecordType->papFldDes[129]->offset=(short)((char *)&prec->r9ip - (char *)prec);
  pdbRecordType->papFldDes[130]->size=sizeof(prec->r0);
  pdbRecordType->papFldDes[130]->offset=(short)((char *)&prec->r0 - (char *)prec);
  pdbRecordType->papFldDes[131]->size=sizeof(prec->r0n);
  pdbRecordType->papFldDes[131]->offset=(short)((char *)&prec->r0n - (char *)prec);
  pdbRecordType->papFldDes[132]->size=sizeof(prec->r0p);
  pdbRecordType->papFldDes[132]->offset=(short)((char *)&prec->r0p - (char *)prec);
  pdbRecordType->papFldDes[133]->size=sizeof(prec->r1);
  pdbRecordType->papFldDes[133]->offset=(short)((char *)&prec->r1 - (char *)prec);
  pdbRecordType->papFldDes[134]->size=sizeof(prec->r1n);
  pdbRecordType->papFldDes[134]->offset=(short)((char *)&prec->r1n - (char *)prec);
  pdbRecordType->papFldDes[135]->size=sizeof(prec->r1p);
  pdbRecordType->papFldDes[135]->offset=(short)((char *)&prec->r1p - (char *)prec);
  pdbRecordType->papFldDes[136]->size=sizeof(prec->r2);
  pdbRecordType->papFldDes[136]->offset=(short)((char *)&prec->r2 - (char *)prec);
  pdbRecordType->papFldDes[137]->size=sizeof(prec->r2n);
  pdbRecordType->papFldDes[137]->offset=(short)((char *)&prec->r2n - (char *)prec);
  pdbRecordType->papFldDes[138]->size=sizeof(prec->r2p);
  pdbRecordType->papFldDes[138]->offset=(short)((char *)&prec->r2p - (char *)prec);
  pdbRecordType->papFldDes[139]->size=sizeof(prec->r3);
  pdbRecordType->papFldDes[139]->offset=(short)((char *)&prec->r3 - (char *)prec);
  pdbRecordType->papFldDes[140]->size=sizeof(prec->r3n);
  pdbRecordType->papFldDes[140]->offset=(short)((char *)&prec->r3n - (char *)prec);
  pdbRecordType->papFldDes[141]->size=sizeof(prec->r3p);
  pdbRecordType->papFldDes[141]->offset=(short)((char *)&prec->r3p - (char *)prec);
  pdbRecordType->papFldDes[142]->size=sizeof(prec->r4);
  pdbRecordType->papFldDes[142]->offset=(short)((char *)&prec->r4 - (char *)prec);
  pdbRecordType->papFldDes[143]->size=sizeof(prec->r4n);
  pdbRecordType->papFldDes[143]->offset=(short)((char *)&prec->r4n - (char *)prec);
  pdbRecordType->papFldDes[144]->size=sizeof(prec->r4p);
  pdbRecordType->papFldDes[144]->offset=(short)((char *)&prec->r4p - (char *)prec);
  pdbRecordType->papFldDes[145]->size=sizeof(prec->r5);
  pdbRecordType->papFldDes[145]->offset=(short)((char *)&prec->r5 - (char *)prec);
  pdbRecordType->papFldDes[146]->size=sizeof(prec->r5n);
  pdbRecordType->papFldDes[146]->offset=(short)((char *)&prec->r5n - (char *)prec);
  pdbRecordType->papFldDes[147]->size=sizeof(prec->r5p);
  pdbRecordType->papFldDes[147]->offset=(short)((char *)&prec->r5p - (char *)prec);
  pdbRecordType->papFldDes[148]->size=sizeof(prec->r6);
  pdbRecordType->papFldDes[148]->offset=(short)((char *)&prec->r6 - (char *)prec);
  pdbRecordType->papFldDes[149]->size=sizeof(prec->r6n);
  pdbRecordType->papFldDes[149]->offset=(short)((char *)&prec->r6n - (char *)prec);
  pdbRecordType->papFldDes[150]->size=sizeof(prec->r6p);
  pdbRecordType->papFldDes[150]->offset=(short)((char *)&prec->r6p - (char *)prec);
  pdbRecordType->papFldDes[151]->size=sizeof(prec->r7);
  pdbRecordType->papFldDes[151]->offset=(short)((char *)&prec->r7 - (char *)prec);
  pdbRecordType->papFldDes[152]->size=sizeof(prec->r7n);
  pdbRecordType->papFldDes[152]->offset=(short)((char *)&prec->r7n - (char *)prec);
  pdbRecordType->papFldDes[153]->size=sizeof(prec->r7p);
  pdbRecordType->papFldDes[153]->offset=(short)((char *)&prec->r7p - (char *)prec);
  pdbRecordType->papFldDes[154]->size=sizeof(prec->r8);
  pdbRecordType->papFldDes[154]->offset=(short)((char *)&prec->r8 - (char *)prec);
  pdbRecordType->papFldDes[155]->size=sizeof(prec->r8n);
  pdbRecordType->papFldDes[155]->offset=(short)((char *)&prec->r8n - (char *)prec);
  pdbRecordType->papFldDes[156]->size=sizeof(prec->r8p);
  pdbRecordType->papFldDes[156]->offset=(short)((char *)&prec->r8p - (char *)prec);
  pdbRecordType->papFldDes[157]->size=sizeof(prec->r9);
  pdbRecordType->papFldDes[157]->offset=(short)((char *)&prec->r9 - (char *)prec);
  pdbRecordType->papFldDes[158]->size=sizeof(prec->r9n);
  pdbRecordType->papFldDes[158]->offset=(short)((char *)&prec->r9n - (char *)prec);
  pdbRecordType->papFldDes[159]->size=sizeof(prec->r9p);
  pdbRecordType->papFldDes[159]->offset=(short)((char *)&prec->r9p - (char *)prec);
  pdbRecordType->papFldDes[160]->size=sizeof(prec->r0nm);
  pdbRecordType->papFldDes[160]->offset=(short)((char *)&prec->r0nm - (char *)prec);
  pdbRecordType->papFldDes[161]->size=sizeof(prec->r1nm);
  pdbRecordType->papFldDes[161]->offset=(short)((char *)&prec->r1nm - (char *)prec);
  pdbRecordType->papFldDes[162]->size=sizeof(prec->r2nm);
  pdbRecordType->papFldDes[162]->offset=(short)((char *)&prec->r2nm - (char *)prec);
  pdbRecordType->papFldDes[163]->size=sizeof(prec->r3nm);
  pdbRecordType->papFldDes[163]->offset=(short)((char *)&prec->r3nm - (char *)prec);
  pdbRecordType->papFldDes[164]->size=sizeof(prec->r4nm);
  pdbRecordType->papFldDes[164]->offset=(short)((char *)&prec->r4nm - (char *)prec);
  pdbRecordType->papFldDes[165]->size=sizeof(prec->r5nm);
  pdbRecordType->papFldDes[165]->offset=(short)((char *)&prec->r5nm - (char *)prec);
  pdbRecordType->papFldDes[166]->size=sizeof(prec->r6nm);
  pdbRecordType->papFldDes[166]->offset=(short)((char *)&prec->r6nm - (char *)prec);
  pdbRecordType->papFldDes[167]->size=sizeof(prec->r7nm);
  pdbRecordType->papFldDes[167]->offset=(short)((char *)&prec->r7nm - (char *)prec);
  pdbRecordType->papFldDes[168]->size=sizeof(prec->r8nm);
  pdbRecordType->papFldDes[168]->offset=(short)((char *)&prec->r8nm - (char *)prec);
  pdbRecordType->papFldDes[169]->size=sizeof(prec->r9nm);
  pdbRecordType->papFldDes[169]->offset=(short)((char *)&prec->r9nm - (char *)prec);
    pdbRecordType->rec_size = sizeof(*prec);
    return(0);
}
#endif /*GEN_SIZE_OFFSET*/
